<template>
  <div>
    <v-dialog
        v-model="dialog"
        width="500"
        :retain-focus="false"
    >
      <template v-slot:activator="{ on, attrs }">
        <v-card
            max-width="400"
            class="mx-auto"
        >
          <v-app-bar
              dark
              color="green darken-2"
              v-bind="attrs"
              v-on="on"
          >
            <div class="text-center">
              <v-toolbar-title>Créer un(e) : {{ url.toUpperCase() }}</v-toolbar-title>
            </div>
          </v-app-bar>
        </v-card>
      </template>
      <v-card>
        <v-form>
          <v-card-title class="headline grey lighten-2">
            Créer
          </v-card-title>
          <br>
          <div v-for="(value, key) in structure">
            <v-text-field
                outlined
                :type="value"
                :placeholder="key"
                :label="key"
                v-model="form[key]"></v-text-field>
          </div>
          <div class="text-center">
            <v-btn @click="createItem" color="green">Valider</v-btn>
          </div>
        </v-form>
        <v-divider></v-divider>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
              color="primary"
              text
              @click="dialog = false"
          >
            Quitter
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>

export default {
  name: "Create",
  props: {
    structure: Object,
    url: String,
    items: Array
  },
  data() {
    return{
      form: {},
      dialog: false
    }
  },
  methods: {
    createItem(){
      this.$axios.post(`/${this.url}`, this.form) // url = clients ou factures ou produits
    },

    // Cette fonction été censé rafraîchir les données de "items" avec ce qui a été créé en plus dans le formulaire.
    // Nous avons décidé de laisser cette fonction ici pour montrer une piste de recherche sur cet axe d'amélioration.
    testCreateRefresh(){
      this.$axios.post(`${this.url}`, {
      }).then((response) => {
        this.getTest()
        this.form = response.data.msg
      }).catch((erreur) => {
        console.log(erreur)
      })
    },
    getTest(){
      this.$axios.get(`${this.url}`)
    }
  }
}
</script>

<style scoped>

</style>